/**
 **	list.c
 **
 **	Published / author: 1999-May-31 / grymse@alhem.net
 **/

/*
Copyright (C) 1999  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "list.h"

	STRING *stringbase;

STRING *name2string(char *s)
{
static	STRING *st;

	for (st = stringbase; st; st = st -> next)
		if (*st -> s == *s && !strcmp(st -> s,s))
			break;
	return st;
}

void addfast(void *_base,void *_item)
{
	LIST0 **base = (LIST0 **)_base;
	LIST0 *item = (LIST0 *)_item;

	item -> next = *base;
	*base = item;
}

void addlist(void *_base,void *_item)
{
	LIST0 **base = (LIST0 **)_base;
	LIST0 *item = (LIST0 *)_item,*q;

	item -> next = NULL;
	q = *base;
	if (!q)
		*base = item;
	else
	{
		while (q -> next)
			q = q -> next;
		q -> next = item;
	}
}

void addliststring(void *_base,void *_item)
{
	STRING **base = (STRING **)_base;
	STRING *item = (STRING *)_item;
	STRING *q,*prev;

	item -> next = NULL;
	if (!*base)
		*base = item;
	else
	{
		q = *base;
		if (*item -> s < *q -> s || strcasecmp(item -> s,q -> s) < 0)
		{
			item -> next = q;
			*base = item;
		} else
		{
			prev = q;
			for (q = q -> next; q; q = q -> next)
				if (*item -> s < *q -> s || strcasecmp(item -> s,q -> s) < 0)
				{
					break;
				} else
					prev = q;
			item -> next = q;
			prev -> next = item;
		}
	}
}

void removelist(void *_base,void *_it)
{
	LIST0 **base = (LIST0 **)_base;
	LIST0 *item = (LIST0 *)_it,*q;
	
	if (*base == item)
		*base = item -> next;
	else
	{
		for (q = *base; q; q = q -> next)
			if (q -> next == item)
			{
				q -> next = item -> next;
				break;
			}
	}
	delete item;
}

void freelist(void *_base)
{
	LIST0 *base = (LIST0 *)_base;
	LIST0 *f;
	
	while (base)
	{
		f = base;
		base = f -> next;
		delete f;
	}
}

long listlen(void *_base)
{
	long l = 0;
	LIST0 *base = (LIST0 *)_base;
	LIST0 *q;
	
	for (q = base; q; q = q -> next)
		l++;
	return l;
}
